commit 1caca76928ab46cba0b85a649ff6f22a1c1d05c4
Author: Jonathan Wakely <jwakely@redhat.com>
Date:   Thu Aug 26 14:13:27 2021

    libstdc++: Add static assertions for std::function requirements
    
    Add static assertions to std::function, so that more user-friendly
    diagnostics are given when trying to store a non-copyable target object.
    
    These preconditions were added as "Mandates:" by LWG 2447, but I'm
    committing them separately from implementing that, to allow just this
    change to be backported more easily.
    
    Signed-off-by: Jonathan Wakely <jwakely@redhat.com>
    
    libstdc++-v3/ChangeLog:
    
            * include/bits/std_function.h (function::function(F)): Add
            static assertions to check constructibility requirements.
    
    (cherry picked from commit 8cf428bfd3ca967b3d135e311d3e391998a39335)

diff --git a/libstdc++-v3/include/bits/std_function.h b/libstdc++-v3/include/bits/std_function.h
index fb86ff1c5f8..e081cd81ef4 100644
--- a/libstdc++-v3/include/bits/std_function.h
+++ b/libstdc++-v3/include/bits/std_function.h
@@ -422,6 +422,12 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
 	function(_Functor __f)
 	: _Function_base()
 	{
+	  static_assert(is_copy_constructible<_Functor>::value,
+	      "std::function target must be copy-constructible");
+	  static_assert(is_constructible<_Functor, _Functor>::value,
+	      "std::function target must be constructible from the "
+	      "constructor argument");
+
 	  using _My_handler = _Function_handler<_Res(_ArgTypes...), _Functor>;
 
 	  if (_My_handler::_M_not_empty_function(__f))

